/*****************************************************************************
 *****************************************************************************
 Copyright (c) 1999 - 2000, Intel Corporation 

 All rights reserved.

 Redistribution and use in source and binary forms, with or without 
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.

 3. Neither the name of Intel Corporation nor the names of its contributors 
    may be used to endorse or promote products derived from this software 
    without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 

 *****************************************************************************
 ****************************************************************************/

 /***************************************************************************
 **                                                                        **
 ** INTEL CORPORATION                                                      **
 **                                                                        **
 ** This software is supplied under the terms of the license included      **
 ** above.  All use of this software must be in accordance with the terms  **
 ** of that license.                                                       **
 **                                                                        **
 **  THIS FILE IS INCLUDED BY ians_core.o. HENCE, IT SHOULD NOT BE         **
 **  MODIFIED!                                                             **
 **                                                                        **
 **  Module Name:                                                          **
 **    incg_gp_mem.h                                                       **
 **                                                                        **
 **  Abstract:                                                             ** 
 **    This module handles memory allocation and freeing for iANS.         **
 **                                                                        **
 **  Environment:                                                          **
 **    Kernel Mode (linux 2.2.x, 2.4.x)                                    **
 **                                                                        **
 ***************************************************************************/


#ifndef _INCG_GP_MEM_H_
#define _INCG_GP_MEM_H_

#ifndef MEM_DEBUG

void iNCGGPSizedMemAlloc(void **ppObj, int Size);
   
void iNCGGPSizedMemFree(void **ppObj, int Size);

void iNCGGPMemFree(void **ppObj);

#else

#define iNCGGPSizedMemAlloc(ppObj, Size) { debugConfigErr(("Alloc size: %d", (Size) )); \
                                           iNCGGPSizedMemAlloc2( (ppObj), (Size) ); }

#define iNCGGPSizedMemFree(ppObj, Size)  { debugConfigErr(("Free size: %d", (Size) )); \
                                           iNCGGPSizedMemFree2( (ppObj), (Size) ); }

#define iNCGGPMemFree(ppObj)             { debugConfigErr(("Free")); \
                                           iNCGGPMemFree2( (ppObj) ); }


void iNCGGPSizedMemAlloc2(void **ppObj, int Size);
   
void iNCGGPSizedMemFree2(void **ppObj, int Size);

void iNCGGPMemFree2(void **ppObj);

int iNCGGPMemGetAllocCount(void);

#endif  //MEM_DEBUG

#endif /* _INCG_GP_MEM_H_ */




